{+doc
+NOMBRE: Math01
+CREACION: 1990
+AUTORES: rch
+REGISTRO:
+TIPO: Unidad Pascal.
+PROPOSITO: definicin de algortmos para buscar raices de funciones
	reales.
+PROYECTO: rchlib
+REVISION:
+AUTOR:
+DESCRIPCION:
-doc}

unit math01;
interface
uses
	xMatDefs;
type
	FdeX=function(x:NReal):NReal;

procedure Dicot(
	f:FdeX;							{funcin a anular}
	x0,x1,xtol:NReal;          {extremos y tolerancia}
	MaxIts:word;					{nmero mximo de iteraciones}
	var Root,fAtRoot:NReal;    {raz y f(raz)}
	var NoOfIts:word;          {nmero de iteraciones realizadas}
	var converged:boolean);		{valids del resultado}

procedure Secant(
	f:FdeX; 							{funcin a anular}
	x0,x1,xtol:NReal;				{valores iniciales de x y tolerancia}
	MaxIts:word;					{nmero mximo de iteraciones}
	var Root, fAtRoot: NReal;	{raz y f(raz)}
	var NoOfIts: word;			{nmero de iteraciones realizadas}
	var converged: boolean);	{valids del resultado}

implementation

procedure Dicot(
	f:FdeX;							{funcin a anular}
	x0,x1,xtol:NReal;          {extremos y tolerancia}
	MaxIts:word;					{nmero mximo de iteraciones}
	var Root,fAtRoot:NReal;    {raz y f(raz)}
	var NoOfIts:word;          {nmero de iteraciones realizadas}
	var converged:boolean);		{valids del resultado}
var
	x,fx,f0:NReal;
	ItCount:word;
	state:(Iterating,WithinTol,MaxItsReached,EqualSigns);
begin
	if x0>x1 then
		begin
			x:=x0;x0:=x1;x1:=x
		end;
	f0:=f(x0);
	ItCount:=0;
	fx:=f(x1);
	if f0*fx<=0 then
		begin
			state:=Iterating;
			repeat
				inc(ItCount);
				x:=(x0+x1)/2; fx:=f(x);
				if f0*fx<=0 then x1:=x else
					begin
						x0:=x;f0:=fx
					end;
				if x1-x0<=xTol then state := WithinTol else
				if ItCount=MaxIts then state:= MaxItsReached
			until state<>iterating;
		end
	else state:=EqualSigns;
	converged:=state=WithInTol;
	Root:=(x0+x1)/2; fAtRoot:=f(root);
	NoOfIts:=ItCount
end; {Dicot }

procedure Secant(
	f:FdeX; 							{funcin a anular}
	x0,x1,xtol:NReal;           {valores iniciales de x y tolerancia}
	MaxIts:word;					{nmero mximo de iteraciones}
	var Root, fAtRoot: NReal;	{raz y f(raz)}
	var NoOfIts: word;			{nmero de iteraciones realizadas}
	var converged: boolean);	{valids del resultado}

var
	xs,x,fx,xa,fa,df,dx:NReal;
	ItCount:word;
	state:(Iterating,WithinTol,MaxItsReached,DivByZero);
begin
	xa:=x0;
	fa:=f(x0);
	x:=x1;
	fx:=f(x1);
	ItCount:=0;
	state:=iterating;
	while state = iterating do
	begin
		df:=fx - fa;
		if df <> 0 then
		begin
			inc(ItCount);
			dx:=(x-xa);
         xa:=x; fa:= fx;
			x:=x - fx * dx/df;
			fx:= f(x);

			if ItCount = MaxIts then state:= MaxItsReached;
			if abs(dx)<xtol then
					state:= WithinTol;
		end
		else state:= DivByZero
	end;
   converged:=state=WithInTol;
	if fx = 0 then converged:=true;
	Root:=x; fAtRoot:=fx;
	NoOfIts:=ItCount
end;
end.