{$IFNDEF WINDOWS}
{$O+,F+,D-,L-}
{$ENDIF}

{ Definiciones Corrientes para uso en matemticas }
unit xMatDefs;
interface

type

(* Con la siguiente definicin, ganamos ademas de precisin
velocidad cuando estemos usando un coprocesador numrico.
	Si se estan utilizando las rutinas de emulacin, se aumenta
la precisin pero obiamente la velocidaddecrece.
	!!!OJO: no utilizar el tipo Real mezclado con estas cosas,
	supongamos que salvamos un archivo un nmero real, pasa a ser
	una complicacin leerlo ya que podemos haber cambiado las
	opciones de compilacin.

	Los programas que esten pensados para uso general debern
poder reconocer con que estado se salv un archivo, para lo
cual se deber salvar tambin un indicativo.

	LO MS SANO ES DEJAR LAS OPCIONES DE COMPILACIN SIEMPRE
CON N+, E+  AUNQUE SE PIERDA VELOCIDAD CUANDO NO SE TENGA
COPROCESADOR.

	EL problema del aumento de tamao de los vectores de reales
es solo un corriemiento del lmite que ya teniamos cuando
usabamos reales solamente. La solucin al problema pasa por
el uso de espacios de memoria virtual, para lo que hemos
desarrollado los Vectores Gigantes Paginads (VGP) *)
 
{$IFOPT N+}
	NReal = extended;
{$ELSE}
	NReal = real;
{$ENDIF}
  PNReal = ^NReal;


{$IFNDEF ENTERO_LONGINT}
	NEntero = integer;
{$ELSE}
	NEntero = longint;
{$ENDIF}
	PNEntero = ^NEntero;

{ Redefinicion de los timpos estandar para que el compilador detecte
como un error el uso indebido de los mismos }
	extended = boolean;
  	real = boolean;


{ Las siguientes constantes son calculadas en el auto-arranque de
la unidad por lo que no es aconsejable utilizarlas en los procedimientos
de auto-arranque de otras unidades pues de hacerlo habr que tener
}
var
	AsumaCero: NReal; {EPSILON de la maquina en cuentas con NReal } 
	DosPi: NReal;		{ 2*Pi }

{ abs(x) < AsumaCero }
function EsCero( x: NReal ): boolean;

{ Casi0:= Abs(x)< xCero.
	xCero debe ser un numero positivo }
function Casi0( x: NReal; xCero: NReal): boolean;

implementation

function EsCero( x: NReal ): boolean;
begin
	EsCero := Abs(x) < AsumaCero;
end;

function Casi0( x: NReal; xCero: NReal): boolean;
begin
	Casi0:= abs(x) < xCero;
end;


function calceps:NReal;
{calceps
  This function returns the machine EPSILON or floating point tolerance,
  the smallest positive real number such that 1.0 + EPSILON > 1.0.
  EPSILON is needed to set various tolerances for different algorithms.
  While it could be entered as a constant, I prefer to calculate it, since
  users tend to move software between machines without paying attention to
  the computing environment. Note that more complete routines exist.
}
var
  e,e0: NReal;
  i: integer;
begin {calculate machine epsilon}
  e0 := 1; i:=0;
  repeat
    e0 := e0/2; e := 1+e0;  i := i+1;
  until (e=1.0) or (i=50000); {note safety check}
  e0 := e0*2;
{ Writeln('Machine EPSILON =',e0);}
  calceps:=e0;
end; {calceps}

begin
	AsumaCero:= CalcEps;
	DosPi:= 2*Pi;	
end.